;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************








opcode_DEC:

opcode_DEC_ZP:
			nop
			LoadZ opc_DEC_ZP_1
			rjmp read_ZP

	opc_DEC_ZP_1:
			dec oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 18
			RWAIT 0
			rjmp mod_write_ZP

opcode_DEC_ZPX:
			nop
			LoadZ opc_DEC_ZP_1
			RWAIT 0
			rjmp read_ZPX


opcode_DEC_Abs:
			LoadZ opc_DEC_Abs_1
			andi reg_Status, 0b11111001
			rjmp read_Absolute

		opc_DEC_Abs_1:
			dec oparand
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_Absolute
			
opcode_DEC_Abs_X:
			LoadZ opc_DEC_Abs_1
			andi reg_Status, 0b11111001
			RWAIT 0
			rjmp read_Absolute_X






opcode_INC:

opcode_INC_ZP:
			nop
			LoadZ opc_INC_ZP_1
			rjmp read_ZP

	opc_INC_ZP_1:
			RWAIT 18
			inc oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_ZP

opcode_INC_ZPX:
			nop
			LoadZ opc_INC_ZP_1
			RWAIT 0
			rjmp read_ZPX


opcode_INC_Abs:
			andi reg_Status, 0b11111001
			LoadZ opc_INC_Abs_1
			rjmp read_Absolute

		opc_INC_Abs_1:
			inc oparand
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 0
			rjmp mod_write_Absolute
			
opcode_INC_Abs_X:
			andi reg_Status, 0b11111001
			LoadZ opc_INC_Abs_1
			RWAIT 0
			rjmp read_Absolute_X


opc_InDe_warte:
			in temp, SREG
			RWAIT 19
			READ_RDY

			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			RWAIT 10
			rjmp main_loop

opcode_DEY:
			dec reg_Y
			rjmp opc_InDe_warte

opcode_INY:
			inc reg_Y
			rjmp opc_InDe_warte

opcode_INX:
			inc reg_X
			rjmp opc_InDe_warte

opcode_DEX:
			dec reg_X
			rjmp opc_InDe_warte





















