;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************



opcode_PHP:
			RWAIT 15
			READ_RDY
			mov temp, reg_Status2
			;lsr temp
			;lsr temp
			mov temp2, reg_Status
			andi temp2, 0b00000011
			or temp2, temp
			bld reg_Status, 0x02
			bst temp2, 0x07
			bld reg_Status, 0x03
			bst temp2, 0x06
			; I-Flag aus IO auslesen???
			mov YL, reg_SP
			dec reg_SP
			ldi YH, 0x01
			RWAIT 11
			st Y, temp2
			RWAIT 9
			rjmp main_loop



opcode_PLP:
			RWAIT 18
			inc reg_SP
			mov YL, reg_SP
			ldi YH, 0x01
			READ_RDY
			ld reg_Status2, Y
			mov reg_Status, temp
			andi reg_Status, 0b00000011
			bld reg_Status2, 0x07
			bst reg_Status, 0x02
			bld reg_Status2, 0x06
			bst reg_Status, 0x03
			;lsl reg_Status2
			;lsl reg_Status2
			andi reg_Status2, 0b00011100
			RWAIT 11
			READ_RDY
			RWAIT 2
			READ_RDY
			RWAIT 7
			rjmp main_loop





opcode_PHA:
			;ldi temp, 0x01
			RWAIT 17
			;WRITE_EXT_RAM reg_SP, temp, reg_A	;4
			nop
			nop
			mov YL, reg_SP
			ldi YH, 0x01
		
			st Y, reg_A
			dec reg_SP

			RWAIT 5
			READ_RDY
			RWAIT 7
			rjmp main_loop
opcode_PLA:
			RWAIT 18
			;ldi temp, 0x01
			;READ_EXT_RAM reg_SP, temp, reg_A	;6
			inc reg_SP
			mov YL, reg_SP
			ldi temp, 0x01
			READ_RDY
			ld reg_A, Y

			RWAIT 4
			READ_RDY
			RWAIT 2
			READ_RDY
			RWAIT 7
			rjmp main_loop
opcode_TXS:
			RWAIT 15
			READ_RDY				;2
			mov reg_SP, reg_X
			RWAIT 8
			rjmp main_loop

opcode_TSX:
			RWAIT 15
			READ_RDY				;2
			mov reg_X, reg_SP
			RWAIT 8
			rjmp main_loop
