;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************







opcode_BPL:
			sbrs reg_Status, flagN
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BMI:
			sbrc reg_Status, flagN
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BVC:
			sbrs reg_Status2, flagV
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BVS:
			sbrc reg_Status2, flagV
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BCC:
			sbrs reg_Status, flagC
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BCS:
			sbrc reg_Status, flagC
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BNE:
			sbrs reg_Status, flagZ
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BEQ:
			sbrc reg_Status, flagZ
			rjmp opcodes_branch
			rjmp opcodes_nobranch

opcodes_branch:
			RWAIT 18
			READ_RDY
			ld temp, X+

			tst temp
			brpl opcode_Branch_2
			neg temp					;????
			sub reg_PCL, temp
			brcs opcode_Branch_3
			RWAIT 9
			READ_RDY
			RWAIT 7
			rjmp main_loop
		opcode_Branch_3:
			sbc reg_PCH, zero
			RWAIT 11
			READ_RDY
			RWAIT 2
			READ_RDY
			RWAIT 7
			rjmp main_loop

		opcode_Branch_2:
			add reg_PCL, temp
			brcs opcode_Branch_4
			RWAIT 9
			READ_RDY
			RWAIT 7
			rjmp main_loop
		opcode_Branch_4:
			adc reg_PCH, zero
			RWAIT 11
			READ_RDY
			RWAIT 2
			READ_RDY
			RWAIT 7
			rjmp main_loop

opcodes_nobranch:
			RWAIT 19
			READ_RDY
			adiw reg_PCL, 0x01
			RWAIT 9
			rjmp main_loop
		

























